;-------------------------------------------------------------------------------------------------------;
;	Author: Nathaniel "Eeems" van Diepen																;
;	Description: A quick way to display an error message in DCS											;
;	Completed: July 27, 2010																			;
;-------------------------------------------------------------------------------------------------------;
;				WARNING USES SafeRam1+129 AND ON TO STORE TEMPORARY DATA								;
;-------------------------------------------------------------------------------------------------------;
;								Add this line to the head of your file									;
;#define dispError(msg,msglength) ld hl,msg \ ld bc,msglength \ push bc \ call DisplayError				;
;	Example msg:																						;
;		msg:																							;
;			.db "Not Implemented",0																		;
;		msgE:																							;
;	Example usage:																						;
;		dispError(msg,msgE-msg)																			;
;					If you want sound add these lines to the top of your file							;
;											#include "Sound.asm"										;
;	#define play(note,length) #ifdef SOUND \ ld hl,note \ ld de,length \ call PlaySound \ #endif		;
;											#define SOUND												;
;							If you want the nice noticable error icon add this							;
;											#define ERROR_ICON											;
;-------------------------------------------------------------------------------------------------------;
#ifdef ERROR_ICON
#define error_icon_width 62
#else
#define error_icon_width 77
#endif
DisplayError:
	ld de,SafeRam1+133
	ldir
	ld hl,SmallWinERR
	ld de,SmallWinERRE-SmallWinERR
	ld a,2
	call PushGUIStack
	ld hl,SmallWinERRButtons
	ld de,SmallWinERRButtonsE-SmallWinERRButtons
	ld a,5
	call PushGUIStack
	pop bc	;stack fix
	ld hl,SafeRam1+129
	pop de
	inc de
	inc de
	inc de
	inc de	;fix size issues
	push bc	;retain original stack top
	ld a,1
	ld (hl),a
	inc hl
	ld a,1
	ld (hl),a
	inc hl
	ld a,error_icon_width
	ld (hl),a
	inc hl
	ld a,0
	ld(hl),a	;load location/width of TextWrap into SafeRam1+129
	ld hl,SafeRam1+129
	ld a,6
	call PushGUIStack
#ifdef ERROR_ICON
	ld hl,error_iconS
	ld de,error_iconE-error_iconS
	ld a,$11
	call PushGUIStack
#endif
	call RenderGUI
#ifdef SOUND
	call Error.sound	;play error sound
#endif
	ld hl,0
	call GUIMouse
DisplayERRClose:
	call ResetAppPage
#ifndef ERROR_ICON
	ld b,3
#else
	ld b,4
#endif
	call PopGUIStacks
	ret
SmallWinERR:
	.db 8,8
	.db %01100000
	.db %01100000
	.db %01100000
	.db %00000000
	.db %01100000
	.db "Error",0
SmallWinERRE:
SmallWinERRButtons:
	;[which {-,[],X,00000}, onclick[-] {word}, onclick[] {word}, onclick[X] {word}]
	.db %00100000
	.dw 0,0
	.dw DisplayERRClose
SmallWinERRButtonsE:
#ifdef SOUND
Error.sound:
#ifdef BlastIt
	singleplay(450,256)
#else
	di
	play(a1,quarter)
	play(b1,quarter)
	play(c1,whole)
	ei
#endif
	ret
#endif
#ifdef ERROR_ICON
error_iconS:
	.db 63,10,2,16	;x,y,w,h
	.db $03,$80		;sprite
	.db $07,$C0
	.db $06,$C0
	.db $0C,$60
	.db $0C,$60
	.db $1C,$70
	.db $1C,$70
	.db $3C,$78
	.db $3C,$78
	.db $7C,$7C
	.db $7E,$FC
	.db $FF,$FE
	.db $FE,$FE
	.db $FC,$7E
	.db $7E,$FC
	.db $3F,$F8
error_iconE:
#endif